### a-stern-CLP.scm

# Da die Stuecke jeweils nicht in alle Alternativen gleichzeitig eingebaut werden, gilt:
# Die Container-liste muss auch die Liste der noch nicht eingebauten Stuecke fuehren!
# Also besser: zustand ist [<container-liste>, <rest-stuecke>]

# Ein Container als tiefe Liste: [Fassungsvermoegen, <Liste der Stuecke>]

# Das Programm benoetigt die ausgegliederten Funktionen:
from prioritaetswarteschlange import *
# mit der Funktion fuegeAlleEin(<wegeliste>, vor, <priows>)
# Prioritaetswarteschlange (Container-liste-1 ...)
# Das Praedikat vor muss dafuer definiert werden:
def vor( zustand1, zustand2):
    return gesamtkosten(zustand1) < gesamtkosten(zustand2)

### ===== Gesamtkosten =====
# Gesamtkosten sind die Kosten zuzueglich Restkosten.
def gesamtkosten(zustand):
    return kosten(zustand[0]) + sum(zustand[1])

### ===== Kosten =====
# Kosten sind die Groessen von Containern, die nicht mehr leer sind,
# was aber belanglos ist (=0)
def kosten(alleContainer):
    dieKosten=0
    for container in alleContainer:
        if len(container[1])>0:
            dieKosten+=container[0]
    return dieKosten
   
### ===== Restkosten =====
# Restkosten sind hier einfach die restlichen Stuecke

# Tests:
##print(gesamtkosten ([[[60, [30]], [50, []], [50, []]], [20, 20, 20, 10]]))
##print(gesamtkosten ([[[60, [30]], [50, []], [50, []]], [30, 20, 20, 20, 10]]))
##print(gesamtkosten ([[[60, [30, 20]], [50, [20]], [50, []]], [20, 10]]))
##print(gesamtkosten ([[[60, [30]], [50, [20]], [50, [20]]], [20, 10]]))
##print(gesamtkosten ([[[60, []], [50, [30, 20]], [50, []]], [20, 10]]))
##print(gesamtkosten ([[[60, [30,30]], [50, [30, 20]], [50, []]], [20, 10]]))
### ===== passt =====
# Hilfsfunktion testet, ob das Stueck noch in den Container passt
def passt(stueck, container):
    return container[0]>=stueck+sum(container[1])

### ===== fuelleEin =====
# fuellt ein Stueck in den Container ein
def fuelleEin(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

# Tests:
##print(fuelleEin(30, [60, []]))

### ===== fuelle =====
# Hilfsfunktion zum Einfuellen eines Stuecks in den n-ten Container
def fuelle(containerListe, stueck, containerNummer): # 0 basierend
    neueListe=containerListe[:containerNummer]
    neueListe.append(fuelleEin(stueck, containerListe[containerNummer]))
    neueListe+=containerListe[(containerNummer+1):]
    return neueListe

# Tests:
##print(fuelle([[60, []], [50, []], [50, []]], 30, 0))
##print(fuelle([[60, []], [50, []], [50, []]], 30, 1))
##print(fuelle([[60, []], [50, []], [50, []]], 30, 2))
     
### ===== erstelleContainerListe =====
# Hilfsfunktion, die zu einer Kapazitaetenliste die Liste der leeren
# Container erstellt.
def erstelleContainerListe(kapazitaetenListe):
    liste=[]
    for kapazitaet in kapazitaetenListe:
        liste.append(erzeugeContainer(kapazitaet))
    return liste
        
### Hilfsfunktion erzeugeContainer
def erzeugeContainer(fassungsvermoegen):
    return [fassungsvermoegen, []]

#Test:
##print(erstelleContainerListe((60, 50, 50)))

### ===== Alternativen =====
# bestimmt die Liste der Moeglichkeiten, das aktuelle Stueck in die
# Container der Container-Liste einzufuegen.
def erzeugeAlternativen(zustand):
    if len(zustand[1])==0: # keine stuecke mehr
        return []
    alternativen=[]
    for i in range(len(zustand[0])):
        if passt(zustand[1][0], zustand[0][i]):
            neuerContainer=fuelle(zustand[0],
                                  zustand[1][0],
                                  i)
            alternativen.append([neuerContainer, zustand[1][1:]])
    return alternativen

#Test:
##print(erzeugeAlternativen([erstelleContainerListe((60, 50, 50)),[30,20,10]]))

### ===== suche =====
def suche(kapazitaetenListe, alleStuecke):
    priows=[[erstelleContainerListe(kapazitaetenListe),alleStuecke]]
    ##print(priows)
    while len(priows)>0:
##        if len(priows)==0: return False    # keine Loesung moeglich
        zustand=priows[0]
        if len(zustand[1])==0:
            return zustand
        ##print(zustand)
        alternativen=erzeugeAlternativen(zustand)
        ##print('Alternativen',alternativen)
        priows=fuegeAlleEin(alternativen, vor , priows[1:])
        AusgabePrioWS(priows)
    return False

def AusgabePrioWS(priows):
    print('PrioWS')
    for alternative in priows:
        print(alternative,gesamtkosten(alternative))

def Ausgabe(kapazitaetenListe, alleStuecke):
    print('Suche mit Kapazitaeten:',kapazitaetenListe, alleStuecke)
    ergebnis=suche(kapazitaetenListe, alleStuecke)
    print(ergebnis, 'Gesamtkosten', gesamtkosten(ergebnis))
    

### ----- Tests -----
Ausgabe((60,50,50), [30,20,20,20,10])
##Ausgabe((60,50,50), [40,30])
##Ausgabe((60,50,50), [40,30,20])
##Ausgabe((60,50,50), [30,30,30,20,30,20])
##Ausgabe((60,50,50), [40,30,30,20,20,20,10])
##Ausgabe((60,50,40), [10,20,20,30,30,40])
##Ausgabe((60,50,40), [40])

##"Tests: erstes Beispiel:"
##def Kapazitaets-Liste-1 '(60 50 50))
##def alle-stuecke '(30 20 20 20 10))
##def leere-Container (erstelle-container-liste Kapazitaets-Liste-1))
##Kapazitaets-Liste-1
##leere-Container
##alle-stuecke
##(suche Kapazitaets-Liste-1 alle-stuecke)
###"-----------------"
##"zweites Beispiel:"
#def Kapazitaets-Liste-2 '(60 60 50))
#def alle-stuecke '(30 20 20 20 10))
#def leere-Container (erstelle-container-liste Kapazitaets-Liste-2))
#Kapazitaets-Liste-2
#leere-Container
#alle-stuecke
#(suche Kapazitaets-Liste-2 alle-stuecke)
###"-----------------"
##"drittes Beispiel:"
#def Kapazitaets-Liste-3 '(60 40 50))
#def alle-stuecke '(30 20 20 20 10))
#def leere-Container (erstelle-container-liste Kapazitaets-Liste-3))
#Kapazitaets-Liste-3
#leere-Container
#alle-stuecke
#(suche Kapazitaets-Liste-3 alle-stuecke)
##"-----------------"
#"viertes Beispiel:"
#def Kapazitaets-Liste-4 '(90 60 40))
#def alle-stuecke '(50 40 30 20 20 20 10))
#def leere-Container (erstelle-container-liste Kapazitaets-Liste-4))
#Kapazitaets-Liste-4
#leere-Container
#alle-stuecke
#(suche Kapazitaets-Liste-4 alle-stuecke)
##"-----------------"
##"fuenftes Beispiel:"
#def Kapazitaets-Liste-5 '(100 100 80 80))
#def alle-stuecke '(60 40 40 30 30 20 20 20 20 20 20 20 20))
#def leere-Container (erstelle-container-liste Kapazitaets-Liste-5))
#Kapazitaets-Liste-5
#leere-Container
#alle-stuecke
#(suche Kapazitaets-Liste-5 alle-stuecke)
##"-----------------"
#"sechstes Beispiel:"
#def Kapazitaets-Liste-6 '(100 100 80 60))
#def alle-stuecke '(55 50 40 30 25 20 20 10 10 5 5))
#def leere-Container (erstelle-container-liste Kapazitaets-Liste-6))
#Kapazitaets-Liste-6
#leere-Container
#alle-stuecke
#(suche Kapazitaets-Liste-6 alle-stuecke)
